function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "zindex";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    $.__views.zindex = Ti.UI.createView({
        id: "zindex"
    });
    $.__views.zindex && $.addTopLevelView($.__views.zindex);
    $.__views.__alloyId4 = Ti.UI.createView({
        top: 0,
        bottom: 50,
        id: "__alloyId4"
    });
    $.__views.zindex.add($.__views.__alloyId4);
    $.__views.view1 = Ti.UI.createView({
        height: 100,
        width: 100,
        left: 0,
        backgroundColor: "green",
        zIndex: 3,
        id: "view1"
    });
    $.__views.__alloyId4.add($.__views.view1);
    $.__views.__alloyId5 = Ti.UI.createLabel({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        color: "#000",
        font: {
            fontSize: 20,
            fontFamily: "Helvetica Neue"
        },
        textAlign: "center",
        text: 1,
        id: "__alloyId5"
    });
    $.__views.view1.add($.__views.__alloyId5);
    $.__views.view2 = Ti.UI.createView({
        height: 100,
        width: 100,
        left: 50,
        backgroundColor: "yellow",
        zIndex: 2,
        id: "view2"
    });
    $.__views.__alloyId4.add($.__views.view2);
    $.__views.__alloyId6 = Ti.UI.createLabel({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        color: "#000",
        font: {
            fontSize: 20,
            fontFamily: "Helvetica Neue"
        },
        textAlign: "center",
        text: 2,
        id: "__alloyId6"
    });
    $.__views.view2.add($.__views.__alloyId6);
    $.__views.view3 = Ti.UI.createView({
        height: 100,
        width: 100,
        left: 100,
        backgroundColor: "red",
        zIndex: 1,
        id: "view3"
    });
    $.__views.__alloyId4.add($.__views.view3);
    $.__views.__alloyId7 = Ti.UI.createLabel({
        width: Ti.UI.SIZE,
        height: Ti.UI.SIZE,
        color: "#000",
        font: {
            fontSize: 20,
            fontFamily: "Helvetica Neue"
        },
        textAlign: "center",
        text: 3,
        id: "__alloyId7"
    });
    $.__views.view3.add($.__views.__alloyId7);
    $.__views.reorder = Ti.UI.createLabel({
        width: Ti.UI.SIZE,
        height: 50,
        color: "#000",
        font: {
            fontSize: 20,
            fontFamily: "Helvetica Neue"
        },
        textAlign: "center",
        bottom: 0,
        text: "reorder",
        id: "reorder"
    });
    $.__views.zindex.add($.__views.reorder);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var ordered = true;
    $.reorder.addEventListener("click", function() {
        console.log("set zIndex " + (ordered ? 1 : 3) + " for view 1");
        console.log("set zIndex " + (ordered ? 3 : 1) + " for view 3");
        $.view1.zIndex = ordered ? 1 : 3;
        $.view3.zIndex = ordered ? 3 : 1;
        ordered = !ordered;
        console.log("view1 zIndex: " + $.view1.zIndex);
        console.log("view3 zIndex: " + $.view3.zIndex);
    });
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;